-- Daily Global Check
-- by Jadya
-- EU-Well of Eternity

-- [[ Mainframe constructor ]]--

local addonName, addonTable = ...
local L = addonTable.L
local C = addonTable.C

local dgcicon = "Interface\\icons\\INV_Sigil_Freya"

local arrowl = "Interface\\icons\\misc_arrowleft"
local arrowr = "Interface\\icons\\misc_arrowright"
local tx_aboutbtn     = "Interface\\icons\\Icon_PetFamily_Beast"
local tx_optionsbtn = "Interface\\icons\\Icon_PetFamily_Mechanical"
local tx_charlist = "Interface\\icons\\Ability_Ambush"
local tx_editbtn = "Interface\\icons\\Garrison_Build"

local chars = DailyGlobalCheck.CharFunctions
local pages = DailyGlobalCheck.PagesFunctions
local options = DailyGlobalCheck.OptFunctions
local constructors = DailyGlobalCheck.Constructors
local editframe = DailyGlobalCheck.EditPanel
local lists = DailyGlobalCheck.ListFunctions
local quest = DailyGlobalCheck.QuestFunctions
local help = DailyGlobalCheck.HelpFunctions
local AddColor = addonTable.AddColor

local opt_framespeed = 20  -- frames animation speed
local centerbuttons_spacing = 80 -- mainframe buttons


-- buttons utils
local starttime = 0
local lastobj
local function StartTimedGlow(obj, t)
--[[
 local function turnoff(f)
  f:SetScript("OnUpdate", nil)
  --ActionButton_HideOverlayGlow(f)
 end

 if lastobj then 
  turnoff(lastobj)
  lastobj = nil
 end
 
 if not obj then return end

 local starttime = GetTime()
 --ActionButton_ShowOverlayGlow(obj)
 obj:SetScript("OnUpdate", function(self) 
  local currtime = GetTime()
  if currtime > starttime + t then
   turnoff(self)
  end
 end)
 lastobj = obj
 ]]
end

local function CheckFramesAnimation(frame)
 if frame and frame:IsVisible() and frame.maxwidth ~= nil and frame.width ~= nil and frame.opening ~= nil then
  if frame.opening then
   if frame.width < frame.maxwidth then
    frame.width = frame.width + opt_framespeed
    frame:SetHeight(frame.width)
   elseif not frame.leftfont:IsVisible() then
    frame.leftfont:Show()
    frame.rightfont:Show()
   end
  else -- closing
   if frame.width > opt_framespeed then
    frame.width = frame.width - opt_framespeed
    frame:SetHeight(frame.width)
    if frame.leftfont:IsVisible() then
     frame.leftfont:Hide()
     frame.rightfont:Hide()
    end
   else
    frame:Hide()
   end
  end
 end
end

local function CreateAboutFrame()

 local btn, f
 f = CreateFrame("Frame")
 f:SetParent(DGC_Mainframe)
 constructors:SetupFrame(f)
 f.width = 1
 f.maxwidth = 200
 f.leftfont:Hide()
 f.rightfont:Hide()
 f:SetFrameStrata("DIALOG")
 f:SetClampedToScreen(true)
 f:ClearAllPoints()
 f:SetPoint("TOPLEFT", DGC_Mainframe, "BOTTOMLEFT")
 f:SetPoint("TOPRIGHT", DGC_Mainframe, "BOTTOMRIGHT")
 
 btn = CreateFrame("FRAME", nil, DGC_Mainframe)
 btn.tex = btn:CreateTexture()
 btn:SetPoint("BOTTOM", DGC_Mainframe, "BOTTOM",centerbuttons_spacing,10)
 btn:SetSize(25,25)
 btn.tex:SetAllPoints()
 btn.tex:SetTexture(tx_aboutbtn)
 btn.enabled = true
 
 f.leftfont:SetText(AddColor(" Daily Global Check ","GOLD").."\n"..
                                         AddColor(" by\n","GRAY")..
                                         AddColor(" Jadya","LIGHT_BLUE")..
                                         AddColor(" EU-Well of Eternity\n\n","GRAY")..
										 AddColor(" Plugins available on Curse:\n","LIGHT_GREEN")..
                                         AddColor(" Daily Global Check_World Bosses\n"..
                                         " Daily Global Check_Isle of Thunder\n"..
                                         " Daily Global Check_Timeless Isle\n"..
                                         " Daily Global Check_Pet Tamers\n"..
										 " Daily Global Check_GarrisonMissions\n"..
										 " Daily Global Check_GarrisonWorkOrders\n"..
										 " Daily Global Check_WoD Rare Mobs\n"..
										 " Daily Global Check_WoD Treasure Chests\n"..
										 " Daily Global Check_Professions\n"..
										 " Daily Global Check_Instance Lockouts\n","GRAY")
										 )
 f.rightfont:SetText("|T"..dgcicon..":24|t\n")

 -- frame's opening/closing animation
 f:SetScript("OnUpdate", function(self)
   CheckFramesAnimation(f)
  end)

  btn:SetScript("OnEnter", function(self)
   if btn.enabled then
    f.opening = true
    f:SetHeight(f.width)
    f:Show()
   end
 end)

  btn:SetScript("OnLeave", function(self)
    f.opening = false 
  end)
 btn:Show()
 
 if f.opening then f:Show() else f:Hide() end
 DGC_Mainframe.fabout = f
 DGC_Mainframe.btnabout = btn
end

function constructors:MainFrame()

 if DGC_Mainframe then return end

 local pluginbtnsize = C.pluginbtnsize
 
 CreateFrame("Frame", "DGC_Mainframe", UIParent)
 local f = DGC_Mainframe
  f:SetPoint("CENTER")
  f:SetMovable(true)
  f:EnableMouse(true)
  f:RegisterForDrag("LeftButton")
  f:SetClampedToScreen(true)
  
  f.LockInEditFrame = function(self)
   --[[
   local editframe = DailyGlobalCheck.EditPanel
   self:SetParent(editframe)
   self:ClearAllPoints()
   self:SetPoint("TOPLEFT", editframe, "TOPRIGHT", -370, -120)
   self:SetPoint("BOTTOMRIGHT", editframe, "BOTTOMRIGHT", -20, 20)
   self:EnableMouse(false)
   self:SetMovable(false)
   self.editmode = true
   self.btnoptions:Hide()
   self.btnchars:Hide()
   self.news_frame:Hide()
   if self.btnchars.open then
    self.btnchars:func()
   end
   self:SetClampedToScreen(false)
   --self:RefreshListButtons()]]
  end
  
  f.Unlock = function(self)
  --[[
   self:SetParent(UIParent)
   self:ClearAllPoints()
   self:SetPoint("CENTER")
   self:EnableMouse(true)
   self:SetMovable(true)
   self.editmode = false
   self.btnoptions:Show()
   self.btnchars:Show()
   self:SetClampedToScreen(true)
   self.news_frame:SetFrameStrata("LOW")
   self.news_frame:Show()
   DailyGlobalCheck:Refresh()
   --self:RefreshListButtons()
   ]]
  end
  
  f.SetAnchor = function(self, anchor)
   if self.editmode then return end
   
   local x,y = self:GetLeft(), self:GetTop()
   self:ClearAllPoints()
   y = -GetScreenHeight() + y
   
   if anchor == "TOPLEFT" then
    self:SetPoint(anchor, UIParent, "TOPLEFT", x, y)
   elseif anchor == "TOPRIGHT" then
    self:SetPoint(anchor, UIParent, "TOPLEFT", x + self:GetWidth(), y)
   elseif anchor == "BOTTOMLEFT" then
    self:SetPoint(anchor, UIParent, "TOPLEFT", x, y - self:GetHeight())
	elseif anchor == "BOTTOMRIGHT" then
    self:SetPoint(anchor, UIParent, "TOPLEFT", x + self:GetWidth(), y - self:GetHeight())
   end
   
   local a1, _, a2, x, y = self:GetPoint()
   DailyGlobalCheck_Options["frame_position"] = {a1, nil, a2, x, y}
  end
  
  local ondragstart = function()
   DGC_Mainframe:StartMoving()
  end
  
  local ondragstop = function()
   DGC_Mainframe:StopMovingOrSizing()
   local a1, _, a2, x, y = DGC_Mainframe:GetPoint()
   DailyGlobalCheck_Options["frame_position"] = {a1, nil, a2, x, y}
  end
  
  f:SetScript("OnDragStart", ondragstart)
  f:SetScript("OnDragStop",  ondragstop)
  constructors:SetupFrame(f)

  -- quest buttons
  f.buttons_container = CreateFrame("Frame", nil, f)
  f.buttons_container:SetPoint("TOPLEFT", f, "TOPLEFT", 2, -60)
  f.buttons_container:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -2, 80)
  f.buttons_container.tex = f.buttons_container:CreateTexture()
  f.buttons_container.tex:SetAllPoints()
  --f.buttons_container.tex:SetTexture(0,1,0,0.3)
  f.buttons = {}
  
  f.HideQuestButtons = function(self, from)
   local length = #(self.buttons)
   
   if from and from > length then return end
   
   for i = from or 1, length do
    self.buttons[i]:Hide()
   end
  end
  
  -- overview mode
  f.SetMode = function(self, mode)
   if not mode or mode == self.mode then return end
   self.mode = mode
   --print("set mode - "..mode)
   DailyGlobalCheck:Refresh()
  end
  
  -- side buttons
  local function btnmode_click(self)
   f:SetAnchor("TOPLEFT")
   DGC_Mainframe:SetMode(self.tag)
  end

  --[[ overview buttons
  f.btnnormal = constructors:CreateStaticBtn(f, arrowl, {"TOPLEFT", f, "TOPLEFT", -25, -25}, {"normal"})
  f.btnnormal.tag = "normal"
  f.btnnormal:SetScript("OnMouseUp", btnmode_click)
  f.btnoverview = constructors:CreateStaticBtn(f, arrowl, {"TOPLEFT", f, "TOPLEFT", -25, -50}, {"overview"})
  f.btnoverview.tag = "overview"
  f.btnoverview:SetScript("OnMouseUp", btnmode_click)
  ]]--
  
  f.Lbtn = constructors:CreateStaticBtn(f, arrowl, {"BOTTOMLEFT", f, "BOTTOMLEFT",10,10}, {L["prevpage"]})
  f.Rbtn = constructors:CreateStaticBtn(f, arrowr, {"BOTTOMRIGHT", f, "BOTTOMRIGHT",-10,10}, {L["nextpage"]})

  f.UpdateArrows = function(self)
      
   if pages:Curr() == 1 then
    self.Lbtn.tex:SetVertexColor(0.4,0.4,0.4,1)
   else
    self.Lbtn.tex:SetVertexColor(1,1,1,1)
   end
   
   if pages:Curr() == pages:Max() then
    self.Rbtn.tex:SetVertexColor(0.4,0.4,0.4,1)
   else
    self.Rbtn.tex:SetVertexColor(1,1,1,1)
   end
  end

  f.Lbtn:SetScript("OnMouseUp", function(self)
   if pages:Move(DailyGlobalCheck:GetSelectedList(), -1) then
    f:SetAnchor("BOTTOMLEFT")
    DailyGlobalCheck:Refresh(DailyGlobalCheck:GetSelectedList())
   end
  end)

  f.Rbtn:SetScript("OnMouseUp", function(self)
   if pages:Move(DailyGlobalCheck:GetSelectedList(), 1) then
    f:SetAnchor("BOTTOMRIGHT")
    DailyGlobalCheck:Refresh(DailyGlobalCheck:GetSelectedList())
   end
  end)

  f:UpdateArrows()
   
  -- about frame
  CreateAboutFrame()

 -- options
 local optframe = options:CreateOptionsFrame(f)
 f.btnoptions = constructors:CreatePanelBtn(f, tx_optionsbtn, optframe, {"BOTTOMRIGHT",f,"BOTTOMRIGHT",-10,40},{GAMEOPTIONS_MENU})
 
 -- characters
 local charframe = chars:CreateCharactersFrame(f)
 f.btnchars = constructors:CreatePanelBtn(f, tx_charlist, charframe, {"BOTTOM",f,"BOTTOM",-centerbuttons_spacing,10},{BINDING_NAME_TOGGLECHARACTER0})

 f.btnedit = constructors:CreateStaticBtn(f, tx_editbtn, {"BOTTOM",f,"BOTTOM",centerbuttons_spacing,40}, {L["edit_mode"]})
 f.btnedit:SetScript("OnMouseUp", function()
    if editframe:IsVisible() then
     editframe:Deactivate()
	else
	 if DGCOptionsFrame:IsVisible() then f.btnoptions:func() end
	 editframe:Activate()
	end
   end)
 
 -- news frame
 help:CreateNewsFrame()
 
-- lists and plugins buttons
-- Mainframe Icon
 f.dgcicon = f:CreateTexture(nil, "OVERLAY")
 f.dgcicon:SetPoint("TOPRIGHT", f, "TOPRIGHT", -20, 10)
 f.dgcicon:SetTexture(dgcicon)
 f.dgcicon:SetSize(50,50)
-- Selected List Title
 f.Ptitle = f:CreateFontString()
 f.Ptitle:SetFont("Fonts\\FRIZQT__.ttf", 20, "")
 f.Ptitle:SetPoint("TOPLEFT", f, "TOPLEFT", 10, -5)
 
-- Character Name
 f.title = f:CreateFontString()
 f.title:SetFont("Fonts\\ARIALN.ttf", 12, "")
 f.title:SetPoint("TOP", f.Ptitle, "BOTTOM", 0, -5)

-- Pages
 f.page = f:CreateFontString()
 f.page:SetFont("Fonts\\ARIALN.ttf", 13, "")
 f.page:SetPoint("BOTTOM", f, "BOTTOM", 0, 40)
 
 DailyGlobalCheck:RefreshTitle()
-- Mainframe fonts offset
 f.leftfont:SetPoint("TOPLEFT",10,-pluginbtnsize * 2)
 f.rightfont:SetPoint("TOPRIGHT",-10,-pluginbtnsize * 2)
 
-- Plugin Buttons
 f.listbuttons = {}

 -- list selection buttons
 f.RefreshListButtons = function(self, hide, list)
  -- if a list is specified, refresh only if it's missing
  if list then
   for _,v in pairs(DGC_Mainframe.listbuttons) do
    if v.list == list then 
	 return
	end
   end
  end
  
  local listbuttons_counter = 1
  local function createlistbutton(_,v)
   local btn
   if f.listbuttons[listbuttons_counter] then
    btn = f.listbuttons[listbuttons_counter]
   else
    btn = constructors:CreateListButton(DGC_Mainframe)
    f.listbuttons[listbuttons_counter] = btn
   end
   btn:SetSize(25,25)
   local pos = listbuttons_counter - 1
   local l = pos % 8
   local r = math.floor(pos / 8) + 1
   btn:SetPoint("TOPLEFT", f, "TOPLEFT", 5 + l + (l * pluginbtnsize), pluginbtnsize * r + 1)  
   btn.list = v["Title"]
   btn.tooltiplines = {v["Title"]}
   if v == DailyGlobalCheck:GetSelectedList() then
    btn:Select()
    StartTimedGlow(btn, 3)
   end
   btn:SetIcon(v["Icon"] and v["Icon"] or tx_qmark)
   btn.clickfunc = function(self)
                    DGC_Mainframe:SetAnchor("TOPLEFT")
                    DailyGlobalCheck:OpenList(self.list)
                   end
   btn:Show()
   listbuttons_counter = listbuttons_counter + 1
  end
 
  table.sort(DailyGlobalCheck.Lists, function(a,b) return string.lower(a["Title"]) < string.lower(b["Title"]) end)
  table.sort(DGC_CustomLists.Lists, function(a,b) return string.lower(a["Title"]) < string.lower(b["Title"]) end)
  for k,v in pairs(self.listbuttons) do
   v:Hide()
  end
  
  if hide then return end
  
  listbuttons_counter = 1
  DailyGlobalCheck:foreachLists(function(k,v)
   if lists:isActive(v) then
    createlistbutton(_, v)
   end
  end)
 end
 f:RefreshListButtons()
 
 f.SelectListButton = function(self, title)
  for i = 1, #(self.listbuttons) do
   if self.listbuttons[i].list == title then
    self.listbuttons[i]:Select()
    StartTimedGlow(self.listbuttons[i], 2)
   else
    self.listbuttons[i]:Deselect()
   end
  end
 end

-- TomTom button
if TomTom then
 f.TomTombutton = constructors:largebuttontemplate(f, "TomTom", L["tomtom_button"])
 f.TomTombutton:SetPoint("BOTTOMLEFT",f,"BOTTOMLEFT",5,40)
 f.TomTombutton:SetBackdropColor(1,0,0.3,1)
 f.TomTombutton:SetScript("OnMouseUp", function()
    if DGCMenuFrame then
     if DGCMenuFrame:IsVisible() then
      DGCMenuFrame:Hide()
     end
 	 DailyGlobalCheck:ShowTomTomMenu()
    end
   end)
end
 -- close button
  f.closebtn = constructors:CreateListButton(f)
  f.closebtn:SetPoint("BOTTOM", f, "BOTTOM",0,10)
  f.closebtn:SetSize(100,25)
  f.closebtn:SetText(CLOSE)
  f.closebtn.clickfunc = function()
                        local f = DGC_Mainframe
						if editframe:IsVisible() then
						 editframe:Deactivate()
						end
                        f:Hide()
                        if DGCMenuFrame then DGCMenuFrame:Hide() end
                        --collectgarbage()
                       end
  f:SetSize(300,150)
  f:Hide()
    
  f:SetMode("normal")
end